"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../Styles/theme");
const Icon_1 = __importDefault(require("../Icon"));
const Search = props => {
    const [value, setValue] = react_1.useState('');
    const $input = react_1.useRef(null);
    const { shape = 'round', textAlign = 'left', placeholder, showClear = true, searchText = '搜索', showSearchText = true, textInputProps = {}, onSearch, onClear, } = props;
    const onSearchText = () => {
        console.log(value);
        onSearch && onSearch(value);
    };
    const onClearText = () => {
        setValue('');
        onClear && onClear();
    };
    return (react_1.default.createElement(react_native_1.View, { style: styles.searchContainer },
        react_1.default.createElement(react_native_1.View, { style: [styles.search, shape === 'round' && styles.round] },
            react_1.default.createElement(Icon_1.default, { name: "search", size: 22, color: theme_1.Theme.colorTextPlaceholder }),
            react_1.default.createElement(react_native_1.TextInput, Object.assign({ ref: $input, style: styles.searchInput, placeholder: placeholder, textAlign: textAlign, placeholderTextColor: theme_1.Theme.colorTextPlaceholder, returnKeyType: "search", blurOnSubmit: true, enablesReturnKeyAutomatically: true, multiline: false }, textInputProps, { value: value, onChangeText: setValue, onSubmitEditing: onSearchText })),
            showClear && !!value && (react_1.default.createElement(Icon_1.default, { name: "close-circle", size: 20, color: theme_1.Theme.colorTextPlaceholder, onPress: onClearText }))),
        showSearchText && (react_1.default.createElement(react_native_1.View, { style: styles.searchTextWrap },
            react_1.default.createElement(react_native_1.Text, { style: styles.searchText, onPress: () => {
                    onSearchText();
                    $input.current?.blur();
                } }, searchText)))));
};
const styles = react_native_1.StyleSheet.create({
    searchContainer: {
        width: '100%',
        flexDirection: 'row',
        alignItems: 'center',
    },
    search: {
        flex: 1,
        flexDirection: 'row',
        alignItems: 'center',
        borderColor: theme_1.Theme.colorIconBase,
        borderWidth: 0.5,
        borderRadius: 4,
        paddingHorizontal: 6,
    },
    round: {
        borderRadius: 16,
    },
    searchInput: {
        flex: 1,
        padding: 0,
        marginLeft: 4,
        height: 32,
        fontSize: 14,
        color: theme_1.Theme.colorTextParagraph,
    },
    searchTextWrap: {
        marginLeft: 8,
    },
    searchText: {
        fontSize: 18,
        color: theme_1.Theme.colorLink,
    },
});
exports.default = Search;
